"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var GunEvent_1 = require("../ControlFlow/GunEvent");
/**
 * Query state around a single node in the graph
 */
var GunGraphNode = /** @class */ (function () {
    function GunGraphNode(graph, soul, updateGraph) {
        this._onDirectQueryReply = this._onDirectQueryReply.bind(this);
        this._data = new GunEvent_1.GunEvent("<GunGraphNode " + soul + ">");
        this._graph = graph;
        this._updateGraph = updateGraph;
        this.soul = soul;
    }
    GunGraphNode.prototype.listenerCount = function () {
        return this._data.listenerCount();
    };
    GunGraphNode.prototype.get = function (cb) {
        if (cb)
            this.on(cb);
        this._ask();
        return this;
    };
    GunGraphNode.prototype.receive = function (data) {
        this._data.trigger(data, this.soul);
        return this;
    };
    GunGraphNode.prototype.on = function (cb) {
        this._data.on(cb);
        return this;
    };
    GunGraphNode.prototype.off = function (cb) {
        if (cb) {
            this._data.off(cb);
        }
        else {
            this._data.reset();
        }
        if (this._endCurQuery && !this._data.listenerCount()) {
            this._endCurQuery();
            this._endCurQuery = undefined;
        }
        return this;
    };
    GunGraphNode.prototype._ask = function () {
        if (this._endCurQuery)
            return;
        return this._graph.get(this.soul, this._onDirectQueryReply);
    };
    GunGraphNode.prototype._onDirectQueryReply = function (msg) {
        var _a;
        if (!msg.put) {
            this._updateGraph((_a = {},
                _a[this.soul] = undefined,
                _a), msg['@']);
        }
    };
    return GunGraphNode;
}());
exports.GunGraphNode = GunGraphNode;
//# sourceMappingURL=GunGraphNode.js.map