import { GunGraphConnector } from './GunGraphConnector';
export declare abstract class GunGraphWireConnector extends GunGraphConnector {
    private _callbacks;
    constructor(name?: string);
    off(msgId: string): this;
    /**
     * Send graph data for one or more nodes
     *
     * @returns A function to be called to clean up callback listeners
     */
    put({ graph, msgId, replyTo, cb }: ChainGunPut): () => void;
    /**
     * Request data for a given soul
     *
     * @returns A function to be called to clean up callback listeners
     */
    get({ soul, cb, msgId, key }: ChainGunGet): () => void;
    /**
     * Send a message that expects responses via @
     *
     * @param msg
     * @param cb
     */
    req(msg: GunMsg, cb?: GunMsgCb): () => void;
    private _onProcessedInput;
}
